package com.jeesite.modules.sso.dao;

import com.jeesite.common.dao.CrudDao;
import com.jeesite.common.mybatis.annotation.MyBatisDao;
import com.jeesite.modules.sso.entity.SsoApp;
import org.apache.ibatis.annotations.Param;

/**
 * 应用接入列表DAO接口
 * @author yinet
 * @version 2022-06-08
 */
@MyBatisDao
public interface SsoAppDao extends CrudDao<SsoApp> {

    /**
     * 根据appid查询接入app列表
     * @param appKey
     * @return
     */
    SsoApp selectAppBykey(String appKey);

    SsoApp selectAppBySecretkey(@Param("appKey") String appKey,@Param("appSecretkey") String appSecretkey);

    /**
     * 修改状态
     * @param id
     * @param type
     * @return
     */
    int changeStatus(@Param("id") String id,@Param("type") String type);

    /**
     * 修改收藏状态
     * @param id
     * @param type
     * @return
     */
    int recommendStatus(@Param("id") String id,@Param("type") String type);

    /**
     * 根据id查询应用
     * @param appId
     * @return
     */
    SsoApp getSsoAppById(String appId);
}