package com.jeesite.modules.admin.wenjuan.entity;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import com.jeesite.common.entity.DataEntity;
import com.jeesite.common.mybatis.annotation.Column;
import com.jeesite.common.mybatis.annotation.Table;
import com.jeesite.common.mybatis.mapper.query.QueryType;

/**
 * 问卷调查选项表Entity
 * @author wlc
 * @version 2022-06-18
 */
@Table(name="admin_question_option", alias="a", label="问卷调查选项表信息", columns={
		@Column(name="questionoption_id", attrName="questionoptionId", label="主键ID", isPK=true),
		@Column(name="questionitem_id", attrName="questionitemId", label="问卷调查项ID"),
		@Column(name="title", attrName="title", label="标题"),
		@Column(name="content", attrName="content", label="内容"),
		@Column(name="is_input", attrName="isInput", label="是否为输入框"),
		@Column(name="count", attrName="count", label="得票数", isUpdateForce=true),
		@Column(name="seq", attrName="seq", label="排序", isUpdateForce=true),
		@Column(name="create_by", attrName="createBy", label="创建者", isUpdate=false, isQuery=false),
		@Column(name="create_date", attrName="createDate", label="创建时间", isUpdate=false, isQuery=false, isUpdateForce=true),
		@Column(name="update_by", attrName="updateBy", label="更新者", isQuery=false),
		@Column(name="update_date", attrName="updateDate", label="更新时间", isQuery=false, isUpdateForce=true),
		@Column(name="remarks", attrName="remarks", label="备注"),
	}, orderBy="a.update_date DESC"
)
public class AdminQuestionOption extends DataEntity<AdminQuestionOption> {
	
	private static final long serialVersionUID = 1L;
	private Long questionoptionId;		// 主键ID
	private Long questionitemId;		// 问卷调查项ID
	private String title;		// 标题
	private String content;		// 内容
	private String isInput;		// 是否为输入框
	private Long count;		// 得票数
	private Long seq;		// 排序
	
	public AdminQuestionOption() {
		this(null);
	}
	
	public AdminQuestionOption(String id){
		super(id);
	}
	
	public Long getQuestionoptionId() {
		return questionoptionId;
	}

	public void setQuestionoptionId(Long questionoptionId) {
		this.questionoptionId = questionoptionId;
	}
	
	@NotNull(message="问卷调查项ID不能为空")
	public Long getQuestionitemId() {
		return questionitemId;
	}

	public void setQuestionitemId(Long questionitemId) {
		this.questionitemId = questionitemId;
	}
	
	@Size(min=0, max=255, message="标题长度不能超过 255 个字符")
	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}
	
	public String getContent() {
		return content;
	}

	public void setContent(String content) {
		this.content = content;
	}
	
	@Size(min=0, max=255, message="是否为输入框长度不能超过 255 个字符")
	public String getIsInput() {
		return isInput;
	}

	public void setIsInput(String isInput) {
		this.isInput = isInput;
	}
	
	public Long getCount() {
		return count;
	}

	public void setCount(Long count) {
		this.count = count;
	}
	
	public Long getSeq() {
		return seq;
	}

	public void setSeq(Long seq) {
		this.seq = seq;
	}
	
}